# Multiple inclusion guard
if (NOT CPP2PY_FOUND) 
set(CPP2PY_FOUND True)

# Version
set(CPP2PY_VERSION                      1.5)
set(CPP2PY_GIT_HASH                     )

# The compiler used for cpp2py
set(CPP2PY_CXX_COMPILER                 /usr/local/bin/clang++60)

# Python Interpreter
set(CPP2PY_PYTHON_INTERPRETER           /usr/local/bin/python2.7)
set(CPP2PY_PYTHON_LIB_DEST_ROOT         lib/python2.7/site-packages)
set(CPP2PY_PYTHON_H5PY_HDF5VERSION      1.10.2)
set(CPP2PY_PYTHON_NUMPY_VERSION_LT_17   )

# Root of the Cpp2Py installation
set(CPP2PY_ROOT  /usr/local)

MESSAGE(STATUS "Found Cpp2pyConfig.cmake with version ${CPP2PY_VERSION}, hash = ${CPP2PY_GIT_HASH}")

# Mac specific
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
 set(CMAKE_INSTALL_NAME_DIR "/usr/local/lib")
 set(CMAKE_MACOSX_RPATH 1) # new for cmake 3.x
endif()

###################################################################################
#
#            Imported targets
#
###################################################################################
# Python
add_library(python_and_numpy SHARED IMPORTED)
set_property(TARGET python_and_numpy PROPERTY IMPORTED_LOCATION /usr/local/lib/python2.7/config/libpython2.7.a)
set_property(TARGET python_and_numpy PROPERTY INTERFACE_INCLUDE_DIRECTORIES /usr/local/include/python2.7 /usr/local/lib/python2.7/site-packages/numpy/core/include)
set_property(TARGET python_and_numpy PROPERTY PROPERTY INTERFACE_LINK_LIBRARIES "-L/usr/local/lib;-lintl;-lutil")
# Does not work ?
#set_property(TARGET python_and_numpy PROPERTY INTERFACE_SYSTEM_INCLUDE_DIRECTORIES /usr/local/include/python2.7 /usr/local/lib/python2.7/site-packages/numpy/core/include)

# tools
add_executable(c++2py IMPORTED)                                                     
set_property(TARGET c++2py PROPERTY IMPORTED_LOCATION "/usr/local/bin/c++2py")

add_executable(c++2rst IMPORTED)                                                     
set_property(TARGET c++2rst PROPERTY IMPORTED_LOCATION "/usr/local/bin/c++2rst")

# include the exported targets of this project 
include(/usr/local/lib/cmake/cpp2py/cpp2py-targets.cmake)

# FIXME : should we just put the rpath in the cpp2y
# FIXME : who needs the rpath ?

###################################################################################
#
#            add_cpp2py_module
#
#   Set up the compilation of the cpp2py python module
# 
#   Argument : ModuleName : name of the module
#   Usage    : 
#              add_cpp2py_module (MyModule)
#               - expects a file MyModule_desc.py in the CURRENT_SOURCE_DIR
#               - add a target MyModule which : 
#                    - DEPENDS on MyModule_desc.py 
#                    - build the wrapper MyModule_wrap.cxx in CURRENT_BINARY_DIR
#                    - compiles it into the MyModule.so
#
###################################################################################
macro (add_cpp2py_module ModuleName)
 message(STATUS "Adding cpp2py Python module ${ModuleName}")

 SET(desc_name  ${CMAKE_CURRENT_SOURCE_DIR}/${ModuleName}_desc.py)    # the desc file
 SET(wrap_name  ${CMAKE_CURRENT_BINARY_DIR}/${ModuleName}_wrap.cxx)   # path to the wrapping code
 SET(target_name ${ModuleName})

 add_custom_command(OUTPUT ${wrap_name} DEPENDS ${desc_name}
  COMMAND PYTHONPATH=${PROJECT_BINARY_DIR}:${PROJECT_BINARY_DIR}/python:${CPP2PY_ADD_MODULE_ADDITIONAL_PYTHONPATH}:$ENV{PYTHONPATH} ${CPP2PY_PYTHON_INTERPRETER} ${desc_name} ${wrap_name}) 
 
 add_library(${target_name} MODULE ${wrap_name}) 
 target_link_libraries(${target_name} python_and_numpy cpp2py)

 set_target_properties(${target_name}
   PROPERTIES
   PREFIX ""  #eliminate the lib in front of the module name
   LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} 
 )

 IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  target_link_libraries(${target_name} "-undefined dynamic_lookup")
 endif()

 # Keep a list of every module target.
 # Usage : e.g.  Documentation top target depends on them being built first 
 set_property(GLOBAL APPEND PROPERTY CPP2PY_MODULES_LIST ${target_name})

endmacro (add_cpp2py_module)

endif (NOT CPP2PY_FOUND) 

